% BYTE.PRO: Theory about bytes.

% A byte is represented by a charstring of '1'-s and '0'-s.


decreasingByteString__has_length([DBS], 1) :-
   zeroByte(DBS),
   !.                         % Solution is sufficient.
decreasingByteString__has_length(DBS, N) :-
                        nat(N),
                        N > 1,
                        N2 is N - 1,
                        N3 is N2 mod 256,
                        nat__eq_bitList__with_length(N3, DBS2, 8),
                        chars__eq_charList(DBS2a, DBS2),
                        decreasingByteString__has_length(DBS3, N2),
                        list__appendedWith_list__is_list([DBS2a], DBS3, DBS),
   !.                         % Solution is sufficient.
decreasingByteString__has_length(DBS, N) :-
   o_exceptionMsg('decreasingByteString__has_length',
                [DBS, N],
                'is queried with wrong second arg'),
   fail.


zeroByteString__has_length([ZBS], 1) :-
   zeroByte(ZBS),
   !.                         % Solution is sufficient.
zeroByteString__has_length(ZBS, N) :-
   nat(N),
   N > 1,
	N1 is N - 1,
	zeroByteString__has_length(ZBS2, N1),
	zeroByte(ZB),
   list__appendedWith_list__is_list([ZB], ZBS2, ZBS),
   !.                         % Solution is sufficient.
zeroByteString__has_length(ZBS, N) :-
   o_exceptionMsg('zeroByteString__has_length',
                [ZBS, N],
                'is queried with wrong second arg'),
   fail.


maxByteString__has_length([MBS], 1) :-
   maxByte(MBS),
   !.                         % Solution is sufficient.
maxByteString__has_length(MBS, N) :-
   nat(N),
   N > 1,
   N1 is N - 1,
   maxByteString__has_length(MBS2, N1),
   maxByte(MB),
   list__appendedWith_list__is_list([MB], MBS2, MBS),
   !.                         % Solution is sufficient.
maxByteString__has_length(MBS, N) :-
   o_exceptionMsg('maxByteString__has_length',
                [MBS, N],
                'is queried with wrong second arg'),
   fail.


zeroByte('00000000').
maxByte('11111111').


% Notes:
% 1. Originally, a byte was defined as a list of '1's and '0's.
%  This appeared however to be impractically inefficient w.r.t.
%  memory usage as well as computing time.
