% I_SNTLST.PRO:  Standard theory about input sentence lists.
% This theory is intended for use with a DCG-type parser: Only spaces,
%  EOR-s and EOF-s are word delimiter.
% Author: Frans A. Meijs, 2000.

i_sentenceList(IS) :-
   i_char(IC),
   i_symb__heads_word__dtBySymb(IC,W,D),
   i_symb__heads_wordList__dtBySymb(W,IS,D),
   !.                                    % Solution is sufficient.   
i_sentenceList([]).


i_symb__heads_wordList__dtBySymb(S,[S|WL],_) :-
   nonvar(S),
   i_char(S2),
   i_symb__heads_word__dtBySymb(S2,W2,D),
   i_symb__heads_wordList__dtBySymb(W2,WL,D),
   !.                                    % Solution is sufficient.
i_symb__heads_wordList__dtBySymb(S,[S],_) :-
   nonvar(S).                                         


i_symb__heads_word__dtBySymb(S,W,D) :-
   i_symb__heads_wordCharList__dtBySymb(S,CL,D),
   chars__eq_charList(W,CL).


i_symb__heads_wordCharList__dtBySymb(C,CL,D) :-
   i_symb__precedes_generalDelimiterStringSymbList__dtBySymb(C,_,C2),
   i_symb__heads_basicWordCharList__dtBySymb(C2,CL,D).


i_symb__heads_basicWordCharList__dtBySymb(' ',[],' ') :-
   !.                                    % Solution is sufficient.
                                         % space char is word delimiter.
i_symb__heads_basicWordCharList__dtBySymb(C,[],C) :-
   endOfRecordSymbol(C),
   !.                                    % Solution is sufficient.
                                         % eor is word delimiter.
i_symb__heads_basicWordCharList__dtBySymb(C,[],C) :-
   endOfFileSymbol(C),
   !.                                    % Solution is sufficient.
                                         % end of file is word delim.
i_symb__heads_basicWordCharList__dtBySymb(C,[C|CL2],D) :-
   i_char(C2),
   i_symb__heads_basicWordCharList__dtBySymb(C2,CL2,D).


