% NUMINTVL.PRO: Standard theory about numeric intervals.
% Author: Frans Meijs, 1998.


% Intervals are ordered pairs. The leftmost quantity being <=
% the rightmost quantity.

numInterval__intersects_numInterval(I1MIN,I1MAX,I2MIN,I2MAX) :-
   number(I1MIN),number(I1MAX),number(I2MIN),number(I2MAX),
   I1MAX >= I2MIN,
   I2MAX >= I1MIN.
numInterval__intersects_numInterval(I1MIN,I1MAX,I2MIN,I2MAX) :-
   ~( numericArguments(I1MIN,I1MAX,I2MIN,I2MAX) ),
   o_exceptionMsg('numericArguments',
                [I1MIN,I1MAX,I2MIN,I2MAX],
                'is queried with wrong arguments'),
   fail.

   % Axiom used:
   % numIntervals I1 and I2 are disjoint if I1MAX < I2MIN | (I2MIN < I1MIN).
   % I1 and I2 intersect if they are not disjoint, i.e.
   %                                  if ~( I1MAX < I2MIN | (I2MIN < I1MIN) ).
   % Now apply De Morgan's theorem.


numericArguments(I1MIN,I1MAX,I2MIN,I2MAX) :-
   number(I1MIN),
   number(I1MAX),
   number(I2MIN),
   number(I2MAX).
 

