% OUTTRAC.PRO: Theory about output traces.


o_verifyingLogMsg(Chars) :-
   chars__eq_flatList(MsgText,
                       ['Searching for contradiction ',Chars]),
   o_consoleMsg(MsgText),
   !.                              % Solution is sufficient.
o_verifyingLogMsg(X) :-
   list__eq_flatList(['Searching for contradiction ',X],
                        MsgText),
   o_consoleMsg(MsgText).


o_parsingLogMsg(Chars) :-
   chars__eq_flatList(MsgText,['Parsing ',Chars]),
   o_consoleMsg(MsgText),
   !.                              % Solution is sufficient.
o_parsingLogMsg(X) :-
   list__eq_flatList(['Parsing ',X],MsgText),
   o_consoleMsg(MsgText).


o_parsingExceptionMsg(S) :-
   exceptionMsgHead(H),
   chars__eq_flatList(CS,[H,'Cannot parse ',S]),
   o_consoleMsg(CS).


o_tracingTell(FileSpec) :- 
   o_consoleMsg(['Opening file ',FileSpec,' for output']),
   tell(FileSpec).


o_trace(MsgText) :-
   prologCputime(T),
   o_consoleMsg(['CPU time ',T,MsgText]).
                         % Use of chars__eq_flatList/2 
                         % intoduced too many problems in the StartToI
                         % code generators.


o_consoleMsg(MsgText) :-
              % "consoleMsg" is a reserved term for BIMprolog.
   telling(FileSpec),
   consoleTell,
   o_chars(MsgText),
   o_eor,
   tell(FileSpec),
   !.                                          % Solution is sufficient.
o_consoleMsg(_).
                        % This theory should always evaluate to "true".

