% POLYNOM.PRO: Theories about polynomials.


root__e_polynomial(X, [A, B, C]) :-
   number(X), number(A), number(B), var(C),
   C is 0 - (B + A * X) * X,
   !.                                      % Solution is sufficient.
root__e_polynomial(X, [A, B, C]) :-
   var(X), number(A), number(B), number(C),
   Aux is B/(2*A),
   Aux2 is Aux*Aux - C/A,
   Aux2 >= 0,
   X is -Aux + sqrt(Aux2).
root__e_polynomial(X, [A, B, C]) :-
   var(X), number(A), number(B), number(C),
   Aux is B/(2*A),
   Aux2 is Aux*Aux - C/A,
   Aux2 >= 0,
   X is -Aux - sqrt(Aux2),
   !.                                      % Solution is sufficient.
                    % Polynomial of degree 2.
root__e_polynomial(X, [A, B, C]) :-
   o_Exception_msg('root__e_polynomial',
              [X,[A,B,C]],
              'is queried with wrong args'),
   fail.


