% PRINTER.PRO: Printer page layout theories.

   % For printing blocks of records which should not contain an EOP witin a block.
   % (Has to be specified at the end of each clause instantiating a block.)
o_alignedEop(BlockSize) :-
   posnat(BlockSize),
   printerPageLength(PageLength),
   int__div_int__is_int(PageLength, BlockSize, PagelengthInBlocks),
   printerBlockNo(BlockNo),
   BlockNo2 is BlockNo + 1,
   retract(printerBlockNo(BlockNo)),
   assert(printerBlockNo(BlockNo2)),
   o_alignedEop__v2(BlockNo2, PagelengthInBlocks),
   !.                                  % Solution is sufficient.
o_alignedEop(X) :-
   o_exceptionMsg('o_alignedEop',
                [X],
                'has improper arguments').
   
o_alignedEop__v2(BlockNo2, PagelengthInBlocks) :-
   BlocksOnPage is BlockNo2 mod PagelengthInBlocks,
   BlocksOnPage == 0,
   o_eop,
   !.                                  % Solution is sufficient.
o_alignedEop__v2(_, _).


printerBlockNo(0).                     % Initial value.

%:- consult('mswin/a4cn11.prp').
