% INCHARS.PRO - Standard theory about input character strings.
% Author: Frans A.Ch. Meijs, 1995
 

i_symb__precedes_generalDelimiterStringSymbList__dtBySymb(S1,[],S2) :-
   nonvar(S1),
   S1 \= ' ',
   ~(endOfRecordSymbol(S1) ),
   S2 = S1,
   !.                                          % Solution is sufficient.
i_symb__precedes_generalDelimiterStringSymbList__dtBySymb(S,[S|GDSSL],S2) :-
                                               % S is a general delimiter.
   nonvar(S),
   i_char(S3),
   ~(endOfFileSymbol(S3) ),
   i_symb__precedes_generalDelimiterStringSymbList__dtBySymb(S3,GDSSL,S2).
i_symb__precedes_generalDelimiterStringSymbList__dtBySymb(S,[E],_) :-
                                               % S precedes an endOfFile
   nonvar(S),
   endOfFileSymbol(E).
                        % An endOfFileSymbol can occur only at the end of
                        % a general delimiter string because it is the last
                        % delimiter which may occur in the input file.

