% INWORD.PRO - Standard theory about input words.
% Author: Frans A.Ch. Meijs, 1995.


i_symb__heads_word__dtBySymb(C,W,D) :-
   i_symb__heads_wordCharList__dtBySymb(C,CL,D),
   chars__eq_charList(W,CL).

i_symb__heads_wordCharList__dtBySymb(C,CL,D) :-
   i_symb__precedes_generalDelimiterStringSymbList__dtBySymb(C,_,C2),
   i_symb__heads_basicWordCharList__dtBySymb(C2,CL,D).


i_symb__heads_basicWordCharList__dtBySymb(';',[],';') :-
   !.                                    % Solution is sufficient.
                                         % semicolon is word delimiter.
i_symb__heads_basicWordCharList__dtBySymb(',',[],',') :-
   !.                                    % Solution is sufficient.
                                         % comma is word delimiter.
i_symb__heads_basicWordCharList__dtBySymb(' ',[],' ') :-
   !.                                    % Solution is sufficient.
                                         % space char is word delimiter.
i_symb__heads_basicWordCharList__dtBySymb(C,[],C) :-
   endOfRecordSymbol(C),
   !.                                    % Solution is sufficient.
                                         % eor is word delimiter.
i_symb__heads_basicWordCharList__dtBySymb(C,[],C) :-
   endOfFileSymbol(C),
   !.                                    % Solution is sufficient.
                                         % end of file is word delim.
i_symb__heads_basicWordCharList__dtBySymb(C,[C|CL2],D) :-
   i_char(C2),
   i_symb__heads_basicWordCharList__dtBySymb(C2,CL2,D).


% :- consult('inchars.pro').
