% MATRIX.PRO: Standard theory about matrix adresses.

%  The adresses are specified by propositions of the form:


%          row__isSubordinateTo_row(R1,R2).
%          column__isSubordinateTo_column(C1,C2).



%----------------------------------------------------------------------
cell__e_row(['c',R,C],['r',R,C]) :-
   ordering__isSubordinateTo_concept(_,['c',R,C]).

cell__e_row(['c',R,C],['r',R,C]) :-
   dimension__e_numberedOrdering(1,['r',R,C]).

row__e_matrix(['r',R,C],['m',R,C]) :-
   ordering__isSubordinateTo_concept(_,['r',R,C]).

row__e_matrix(['r',R,C],['m',R,C]) :-
   dimension__e_numberedOrdering(1,['m',R,C]).


dimension__e_numberedOrdering(1,['r',R,C]) :-
     ordering__isSubordinateTo_concept(['r',R,C],_) ,
  ~( ordering__isSubordinateTo_concept(['r',R,_],['c',R,C]) ).

dimension__e_numberedOrdering(1,['m',R,C]) :-
     row__isSubordinateTo_row(R,_),
  ~( row__isSubordinateTo_row(_,R) ).


ordering__isSubordinateTo_concept(['r',R,C1],['c',R,C2]) :-
  column__isSubordinateTo_column(C1,C2).

ordering__isSubordinateTo_concept(['m',R1,C],['r',R2,C]) :-
  row__isSubordinateTo_row(R1,R2).



