% OUTMATR2.PRO: Standard theory about output matrices.


% This theory is derived from theory OUTMATRI.PRO; it instantiates
% an output matrix with a cell per record. It can be used in the
% same way as theory OUTMATRI.PRO. 

outputMatrix(M) :- 
   o_row__e_matrix(_,M),
   fail.               % The interpreter is forced to find all rows.


o_row__e_matrix(R,M) :-
   dimension__e_numberedOrdering(1,M),
   row__e_matrix(R,M),
   o_rowLabel(R),
   o_cell__e_row(_,R).
o_row__e_matrix(R,M) :-
   ~( dimension__e_numberedOrdering(1,M) ),
   row__e_matrix(R,M),
   ordering__isSubordinateTo_concept(M2,R),
   o_row__e_matrix(_,M2),
   o_rowLabel(R),
   o_cell__e_row(_,R).



o_rowLabel(R) :-
   o_chars('Row '),
   o_chars(R),
   o_chars(':'),
   o_eor.


o_cell__e_row(CE,R) :-
   dimension__e_numberedOrdering(1,R),
   cell__e_row(CE,R),
   matrixCell__represents_concept(CE,I),
   o_spaces(3),
   o_chars(I),
   o_eor.
o_cell__e_row(CE,R) :-
   dimension__e_numberedOrdering(1,R),
   cell__e_row(CE,R),
   ~( matrixCell__represents_concept(CE,_) ),
   o_spaces(4),
   o_chars('.'),
   o_eor.
o_cell__e_row(CE,R) :-
   ~( dimension__e_numberedOrdering(1,R) ),
   cell__e_row(CE,R),
   matrixCell__represents_concept(CE,I),
   ordering__isSubordinateTo_concept(R2,CE),
   o_cell__e_row(_,R2),
   o_spaces(3),
   o_chars(I),
   o_eor.
o_cell__e_row(CE,R) :-
   ~( dimension__e_numberedOrdering(1,R) ),
   cell__e_row(CE,R),
   ~( matrixCell__represents_concept(CE,_) ),
   ordering__isSubordinateTo_concept(R2,CE),
   o_cell__e_row(_,R2),
   o_spaces(4),
   o_chars('.'),
   o_eor.



outputMatrixHeading(['m',R,C]) :-
   o_chars('Column names:'), o_eor,
   o_matrixHeading__v2(['m',R,C]),
   o_eor.

 
outputMatrixHeading__v2(['m',R,C]) :-
   dimension__e_numberedOrdering(1,['r',R,C]),
   o_spaces(3),
   o_chars(C),
   o_eor.  
outputMatrixHeading__v2(['m',R,C]) :-
   ordering__isSubordinateTo_concept(['r',R,C2],['c',R,C]),
   o_matrixHeading_2(['m',R,C2]),
   o_spaces(3),
   o_chars(C),
   o_eor.        
