% OUTPROLO.PRO: Theory about object/output Prolog propositions.
% Author: Frans A.Meijs, 1973.


o_monadicPrologProposition(FUNCTOR,ARG) :-
   o_monadicPrologProposition_v2(FUNCTOR,ARG),
   o_prologPropositionDelimiter.


o_monadicPrologProposition_v2(FUNCTOR,ARG) :-
   o_chars(FUNCTOR),
   o_char('('),
   o_term(ARG),
   o_chars(')').
   
   
o_dyadicPrologProposition(FUNCTOR,ARG1,ARG2) :-
   o_dyadicPrologProposition_v2(FUNCTOR,ARG1,ARG2),
   o_prologPropositionDelimiter.
   

o_dyadicPrologProposition_v2(FUNCTOR,ARG1,ARG2) :-
   o_chars(FUNCTOR),
   o_char('('),
   o_term(ARG1),
   o_char(','),
   o_term(ARG2),
   o_chars(')').


o_triadicPrologProposition(FUNCTOR,ARG1,ARG2,ARG3) :-
   o_triadicPrologProposition_v2(FUNCTOR,ARG1,ARG2,ARG3),
   o_prologPropositionDelimiter.
   

o_triadicPrologProposition_v2(FUNCTOR,ARG1,ARG2,ARG3) :-
   o_chars(FUNCTOR),
   o_char('('),
   o_term(ARG1),
   o_char(','),
   o_term(ARG2),
   o_char(','),
   o_term(ARG3),
   o_chars(')').


o_tetradicPrologProposition(FUNCTOR,ARG1,ARG2,ARG3,ARG4) :-
   o_tetradicPrologProposition_v2(FUNCTOR,ARG1,ARG2,ARG3,ARG4),
   o_prologPropositionDelimiter.
   

o_tetradicPrologProposition_v2(FUNCTOR,ARG1,ARG2,ARG3,ARG4) :-
   o_chars(FUNCTOR),
   o_char('('),
   o_term(ARG1),
   o_char(','),
   o_term(ARG2),
   o_char(','),
   o_term(ARG3),
   o_char(','),
   o_term(ARG4),
   o_chars(')').


o_prologPropositionDelimiter :-
   o_chars('.'),
   o_eor.
   
