% OUTTREE.PRO: Standard theory about output trees.


o_tree(C) :-
   o_vertex__isConnectedWithLeafViaPath(C,_,0),
                          % The depth-first solution search is applied.
   fail.           % The interpreter is forced to search for any other 
                   % solution.


o_vertex__isConnectedWithLeafViaPath(C,[C],PathLength) :-
      o_leaf(C,PathLength),
   ~( o_vertex__isSubordinateTo_vertex(_,C) ),
   !.                                         % Solution is sufficient.
o_vertex__isConnectedWithLeafViaPath(C,[C|P],PathLength) :-
   o_vertex__isSubordinateTo_vertex(C2,C),
   PathLength2 is PathLength + 1,
   o_vertex__isConnectedWithLeafViaPath(C2,P,PathLength2).

