% BENCHMR.PRO: The classical "champagne" benchmark for general unification.

champagne(N) :-
  tree(N, T1),
  tree(N, T2),
  T1 = T2.

tree(0, leaf).
tree(N, node(T, T, T, T, T, T, T, T, T, T)) :-
  N > 0,
  N1 is N-1,
  tree(N1, T).

% Just pass a large enough N to champagne/1, and any Prolog system which
% implements general unification naively will take exponential time
% to check that the trees are equal.
% Courtesy Jens Kilian <Jens_Kilian@bbn.hp.com>, 05 Nov 1998

% 1998 nov: SWIprolog 2.7.15 on a 100Mhz Pentium running Windows95
%           needs approx. 30 minutes for N = 7.
%           XSB 1.8.1 on a HP 9000/735 running HP-UX B.10.20
%           needs approx. 0.5 minute for N = 7.
