% LIST.PRO: Standard theory about lists.
% Unsafe - but faster - version, derived from the safe one.
% Use it ONLY AFTER succesful use of the safe version.


member__isRandomSelectionOf_list(X,L) :-
   list__has_length(L,LL),
   randomNat(RN),
   randomNatDiscr(RND),
   UUP is RND + (LL-1) * RN,
   real__dividedBy_real__is_real(UUP,RND,UP),
   real__isRoundOf_real(P,UP),         % P = 1 + (LL-1) * R,  0 <= R <= 1
   term__isMemberOf_list__at_position(X,L,P).


offset__splits_list__into_list__and_list(N,L,[],L) :-
   N == 0,
%   list(L),
   !.                                      % Solution is sufficient.
offset__splits_list__into_list__and_list(N,L1,L2,L3) :-
%   nat(N),
   N > 0,
%   list(L1),
   N2 is N - 1,
   L1 = [H| L4],
   offset__splits_list__into_list__and_list(N2,L4,L5,L3),
   list__appendedWith_list__is_list([H],L5,L2),
   !.                                      % Solution is sufficient.
offset__splits_list__into_list__and_list(N,L1,L2,L3) :-
   ~( nat(N) ),
   o_exceptionMsg('offset__splits_list__into_list__and_list',
                [N,L1,L2,L3],
                'is queried with wrong first arg'),
   fail.
offset__splits_list__into_list__and_list(N,L1,L2,L3) :-
   ~( list(L1) ),
   o_exceptionMsg('offset__splits_list__into_list__and_list',
                [N,L1,L2,L3],
                'is queried with wrong second arg'),
   fail.


list__eq_flatList(L,FL) :-
%   list(L),
   list__eq_flatList__aux(L,FL,[]),
   !.                                      % Solution is sufficient.
list__eq_flatList(L,FL,_) :-
   o_exceptionMsg('list__eq_flatList',
                [L,FL],
                'is queried with wrong first arg'),
   fail.


list__addedWith_term__is_list(L,T,L2) :-
%   nonvar(L), nonvar(T),
   term__isMemberOf_list__v2(T,L),
   L2 = L,
   !.                                      % Solution is sufficient.
list__addedWith_term__is_list(L1,T,L2) :-
%   nonvar(L1), nonvar(T),
   % ~( term__isMemberOf_list__v2(T,L1) ), % Covered by clause above.
   list__appendedWith_term__is_list(L1,T,L2),
   !.                                      % Solution is sufficient.
list__addedWith_term__is_list(X,Y,Z) :-
   arityOfVars__gt_0(X,Y),
   o_exceptionMsg('list__addedWith_term__is_list',
                [X,Y,Z],
                'is queried with wrong args'),
   fail.
             % The set represented by L2 is the union of the set
             % represented by L1 and the singleton represented by T.



list__subtractedWith_term__is_list(L,T,L2) :-
%   nonvar(L), nonvar(T),
   ~( term__isMemberOf_list__v2(T,L) ),
   L2 = L,
   !.                                         % Solution is sufficient.
list__subtractedWith_term__is_list(L1,T,L2) :-
%   nonvar(L1), nonvar(T),
   % ~( term__isMemberOf_list__v2(T,L2) ), % Covered by clause above.
   L1 = [T| L2],
   !.                                         % Solution is sufficient.
list__subtractedWith_term__is_list([H| L1],T,[H| L2]) :-
%   nonvar(H), nonvar(L1), nonvar(T),
   list__subtractedWith_term__is_list(L1,T,L2),
   !.                                         % Solution is sufficient.
list__subtractedWith_term__is_list(X,Y,Z) :-
   arityOfVars__gt_0(X,Y),
   o_exceptionMsg('list__subtractedWith_term__is_list',
                [X,Y,Z],
                'is queried with wrong args'),
   fail.
             % The set represented by L2 is the difference of the set
             % represented by L1 and the singleton represented by T.



list__appendedWith_term__is_list(L1,T,L2) :-
   ~( list(T) ),
   list__appendedWith_list__is_list(L1,[T],L2),
   !.                                      % Solution is sufficient.
list__appendedWith_term__is_list(L1,L2,L3) :-
   list(L2),
   list__appendedWith_list__is_list(L1,L2,L3).


list__appendedWith_list__is_list(L1,L2,L3) :-
   list__appendedWith_list__is_list__aux(L1,L2,L3),


list__hasSameSetOfMembersAs_list(L,L2) :-
   list__has_length(L,I),
   list__has_length(L2,I),
   list__isSubsetOf_list(L,L2).


list__isProperSubsetOf_list(L,L2) :-
   list__has_length(L,I),
   list__has_length(L2,I2),
   I2 > I,
   list__isSubsetOf_list(L,L2).


list__isSubsetOf_list(L,L2) :-
   ~( list__isNoSubsetOf_list(L,L2) ).


list__isNoSubsetOf_list(L,L2) :-
                               % nonvar(L), nonvar(L2) is covered by 
                               %  term__isMemberOf_list*/2.
   term__isMemberOf_list(M,L),
   ~( term__isMemberOf_list__v2(M,L2) ).


list__withDuplicateMembersRemovedIs_list(L1,L2) :-
%   list(L1),
   list__withDuplicateMembersRemovedIs_list__aux(L1,L2),
   !.                                         % Solution is sufficient.
list__withDuplicateMembersRemovedIs_list(X,Y) :-
   ~( list(X) ),
   o_exceptionMsg('list__withDuplicateMembersRemovedIs_list',
                [X,Y],
                'is queried with wrong first arg'),
   fail.
                  % L2 is sorted.


list__beginsWith_list([L| _],L) :- list(L).


list__endsWith_term([L],L) :-
   !.                                         % Solution is sufficient.
list__endsWith_term(L1,L2) :- 
%   nonvar(L1),
   L1 = [_| L3],
   list__endsWith_term(L3,L2),
   !.                                         % Solution is sufficient.
list__endsWith_term(X,Y) :-
   ~( list(X) ),
   o_exceptionMsg('list__endsWith_term',
                [X,Y],
                'is queried with wrong first arg'),
   fail.


term__isMemberOf_list__at_position(T,L,1) :-
   nonvar(L),
   L = [T|_].
term__isMemberOf_list__at_position(T,L,P) :-
   var(T),nonvar(L),
   L = [_|L2],
   P2 is P - 1,
   term__isMemberOf_list__at_position(T,L2,P2).
term__isMemberOf_list__at_position(T,L,P) :-
   nonvar(T),nonvar(L),var(P),
   L = [_|L2],
   term__isMemberOf_list__at_position(T,L2,P2),
   P is P2 + 1.
term__isMemberOf_list__at_position(X,Y,Z) :-
   var(Y),
   o_exceptionMsg('term__isMemberOf_list__at_position',
                [X,Y,Z],
                'is queried with unbound second arg'),
   fail.

