%  VT100.PRO: VT100 graphic display adapter.
% Derived from Edinburgh's VT100.PL, harmonized with FBAS CONSVIDE.FBA.
% Author: Frans A.Meijs, 09 oct 2000.


consvide_init :-
    '$vedescape'('['),
    write('2J'),
    consvide_placeCursor(0,0).
% Side effect: Erases video display, homes cursor and resets to defaults.


consvide_finish :-
    consvide_init.
% Side effect: Erases video display, homes cursor and resets to defaults.


% consvide_chars: Use o_chars/1.

consvide_eor :-
   TBD


consvide_eraseLineEor


consvide_getCursorLocation


consvide_homeCursor :-
   consvide_placeCursor(1,1).


consvide_message(M) :-
   o_chars(M),
   consvide_eor.


consvide_placeCursor(X,Y) :-
    '$vedescape'('['),
    Y1 is Y + 1,
    '$vedoutint'(Y1),
    write(';'),
    X1 is X + 1,
    '$vedoutint'(X1),
    write('H').


declare sub CONSVIDE.resetColours()
' Side effect: Resets colours of cursor and background to the default state.

declare sub CONSVIDE.setBackgroundColour(colour as SHORTFLOAT)

declare sub CONSVIDE.setCursorColour(relLuminance as SHORTFLOAT,colour as SHORTFLOAT)

declare sub CONSVIDE.setDisplayMode(displayMode as SHORTINT)


%  clear_from(X+,Y+):
%    Move cursor to X,Y and clear rest of page.
clear_from(X,Y) :-
    consvide_placeCursor(X,Y),
    '$vedescape'('['),
    write('J').


%  clear_line(X+,Y+):
%    Move cursor to X,Y and clear rest of line.
clear_line(X,Y) :-
    consvide_placeCursor(X,Y),
    '$vedescape'('['),
    write('K').


%  clear_eol:
%    Clear to end of current line.
clear_eol :-
    '$vedescape'('['),
    write('K').


%  hilight(State+):
%    Inverse video on (State=on) or off (State=off).
hilight(on) :-
    '$vedescape'('['),
    write('7m').
hilight(off) :-
    '$vedescape'('['),
    write('0m').




'$vedoutint'(X) :-
    write(X).
%    Emit X (integer) as its ASCII representation.


'$vedescape'(X) :-
    put(27),
    write(X).  
%    Emit atom X, preceded by an ESC.

